freeslot("sfx_engign")
sfxinfo[sfx_engign].caption = '\x85"Woo-"\x80'
addHook("MobjDeath", function(mo) //Death thing
	if mo and mo.valid and mo.skin == "engineertf2"
		mo.iamagoner = TICRATE
		
		mo.gonerpos = {
			x = mo.x,
			y = mo.y,
			z = mo.z}
		S_StopSound(mo)
	end
end)

local byebye = {
	[0] = 0,
	[1] = FF_TRANS90,
	[2] = FF_TRANS80,
	[3] = FF_TRANS70,
	[4] = FF_TRANS60,
	[5] = FF_TRANS50,
	[6] = FF_TRANS40,
	[7] = FF_TRANS30,
	[8] = FF_TRANS20,
	[9] = FF_TRANS10
}
local function P_ChangeOrigin(mo, x,y,z, inter) --A thing for teleporting stuff
	if (P_MoveOrigin(mo,x,y,z) or P_SetOrigin(mo,x,y,z))
		if inter
			P_MoveOrigin(mo,x,y,z)
		else
			P_SetOrigin(mo,x,y,z)
		end
	elseif P_TeleportMove(mo,x,y,z)
		P_TeleportMove(mo,x,y,z)
	end
end
addHook("MobjThinker", function(mo) //Death think
	if mo and mo.valid
	and mo.iamagoner
		if mo.skin == "engineertf2"
		and mo.gonerpos
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.pmomz = 0
			P_ChangeOrigin(mo,mo.gonerpos.x,mo.gonerpos.y,mo.gonerpos.z,true)
		end
		mo.iamagoner = max($-1,1)
		if mo.iamagoner <= 11
			if byebye[mo.iamagoner-1]
				local bop = byebye[mo.iamagoner-1]
				mo.frame = $|bop
			end
			if mo.iamagoner <= 1
				mo.flags2 = $|MF2_DONTDRAW
				if mo.skin != "engineertf2"
					mo.fuse = 1
					mo.iamagoner = 0
				end
			elseif mo.iamagoner == 11 and mo.skin == "engineertf2"
				S_StartSound(mo,sfx_engign)
			end
		end
		return true
	end
end)
addHook("PlayerThink", function(player) //Player think
	if player.valid and player.playerstate == PST_DEAD
	and not player.spectator and player.mo
	and player.mo.valid and player.mo.skin == "engineertf2"
		if player.mo.iamagoner
			player.cmomx = 0
			player.cmomy = 0
			player.rmomx = 0
			player.rmomy = 0
			if player.mo.iamagoner == 1
			and player.deadtimer < TICRATE*3
				player.deadtimer = TICRATE*3
			end
			return true
		end
	end
end)

addHook("MusicChange", function(o,n)
	if not (consoleplayer and consoleplayer.valid and consoleplayer.mo and consoleplayer.mo.valid
		and consoleplayer.mo.skin == "engineertf2") then return end
	if n == "_inv"
		return "MEDIC"
	end
end)

freeslot("sfx_engiub","SPR_ENGY")
sfxinfo[sfx_engiub].caption = '\x85"Let\'s do this texas style!"\x80'
local function TF2_Ubercharge(mo,mobj,src)
	if src and src.valid
	and src.skin == "engineertf2"
		S_StartSound(mobj,sfx_engiub)
	end
	if mobj and mobj.valid
	and mobj.skin == "engineertf2"
		S_StartSound(mobj,sfx_engiub)
	end
end
addHook("MobjDeath", TF2_Ubercharge,MT_INVULN_GOLDBOX)
addHook("MobjDeath", TF2_Ubercharge,MT_INVULN_BOX)

addHook("MobjSpawn", function(mo)
	if mo and mo.valid
		for p in players.iterate()
			if not (p and p.valid) then continue end
			if not (p.mo and p.mo.valid) then continue end
			if (p.mo.skin != "engineertf2") then continue end
			if not (p.powers[pw_invulnerability]) then continue end
			if (mo.x != p.mo.x or mo.y != p.mo.y or mo.z != p.mo.z) then continue end
			
			mo.state = S_INVISIBLE
			mo.tics = 1
		end
	end
end,MT_IVSP)

addHook("PlayerThink", function(player) //Player think
	if player.valid
	and not player.spectator and player.mo
	and player.mo.valid and player.mo.skin == "engineertf2"
	and player.engi
		local mo = player.mo
		local e = player.engi
		
		if player.powers[pw_invulnerability]
			mo.colorized = true
			mo.color = SKINCOLOR_RED
			local y = P_SpawnGhostMobj(mo)
			local h = mo.height/11*5
			P_SetOrigin(y,mo.x,mo.y,FixedMul((mo.z+mo.height/2)+h*P_MobjFlip(mo),mo.spriteyscale))
			y.sprite = SPR_ENGY
			y.color = SKINCOLOR_YELLOW
			y.blendmode = AST_ADD
			y.momx = mo.momx
			y.momy = mo.momy
			y.momz = mo.momz
			y.spritexscale = mo.spritexscale
			y.spriteyscale = mo.spriteyscale
			y.spritexoffset = mo.spritexoffset
			y.spriteyoffset = mo.spriteyoffset
			y.scalespeed = FRACUNIT/8
			y.destscale = FRACUNIT*2
			P_Thrust(y,player.drawangle,mo.scale/4)
			P_SetObjectMomZ(y,FRACUNIT*2,true)
			
			if player.powers[pw_invulnerability] < TICRATE*3/2
				local o = P_SpawnMobjFromMobj(mo,0,0,0,MT_OVERLAY)
				o.target = mo
				o.state = S_INVISIBLE
				o.tics = 2
				
				o.sprite2 = mo.sprite2
				o.sprite = mo.sprite
				o.frame = mo.frame
				o.skin = mo.skin
				
				o.spritexscale = mo.spritexscale
				o.spriteyscale = mo.spriteyscale
				
				o.spritexoffset = mo.spritexoffset
				o.spriteyoffset = mo.spriteyoffset
				
				o.rollangle = mo.rollangle
				o.angle = player.drawangle
				o.color = SKINCOLOR_ORANGE
				o.colorized = true
				o.blendmode = AST_MODULATE
				
				if (player.powers[pw_invulnerability]%10) > 4
					o.flags2 = $|MF2_DONTDRAW
				else
					o.flags2 = $&~MF2_DONTDRAW
				end
			end
			
			e.wasinvuln = true
		elseif e.wasinvuln
			mo.colorized = false
			mo.color = player.skincolor
			e.wasinvuln = false
		end
	end
end)